//             (C) by Florian Lindner 1998
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include "FButton.h"
#include "ShortCuts.h"
#pragma resource "FComponents.res"
#pragma hdrstop
#pragma option -5 -O2 -OS -d- -fp -O -Oi -Ov -vi-
//---------------------------------------------------------------------------

__fastcall FButton::FButton(TComponent* Owner)
	: TButton(Owner) {
 FUp = true;
 FWidthOrig = this->Width;
}

namespace Fbutton {
 void __fastcall Register() {
  TComponentClass classes[1] = {__classid(FButton)};
  RegisterComponents("FLoh!", classes, 0);
 }
}

void FButton::Enable() { Enabled = true; }

void FButton::Disable() { Enabled = false; }

void FButton::AnimUp(int breite) {
 if (breite > 0) {
  Up = true;
  for (register int i = 0; i<=breite; i++) {
   this->Width = i;
   Update();
  }
 }
}

void FButton::AnimDown(int breite) {
 if (breite > 0) {
  Up = false;
  for (register int i = breite; i>=0; i--) {
   this->Width = i;
   Update();
  }
 }
}

void __fastcall FButton::SetUp(Boolean Value) {
 switch(Value) {
  case true: this->Width = this->WidthOrig;
             FUp = Value;
             break;
  case false: this->Width = 0;
              FUp = Value;
              break;
 }
}

void FButton::Animate(int x) {
 if (Up) { AnimDown(x); }
 else { AnimUp(x); }
}

void __fastcall FButton::SetWidthOrig(int Value) {
 if (Value != FWidthOrig) { FWidthOrig = Value; }
}
